float4x4 view_proj_matrix;
float4x4 view_matrix;
float3 dlightPos;
float specularPower;

float outerRadius;
float time_A;
float time_B;

struct VS_OUTPUT 
{
   float4 Pos : POSITION;   
   float4 c : COLOR0;
   float2 Tex : TEXCOORD0;
   float2 Tex1 : TEXCOORD1;
   float3 Norm : TEXCOORD2;
};

VS_OUTPUT vs_main( float4 inPos: POSITION, float2 inTex: TEXCOORD0, float2 inTex1 : TEXCOORD1, float3 inNorm : NORMAL )
{
   VS_OUTPUT Out;

	float3 vecCenter;
	vecCenter.x = vecCenter.y = vecCenter.z = 0.0f;

	// Relative distance of vertexposition to outer perimeter of the ship
	float fDelta	= abs(distance(vecCenter, inPos.xyz))/outerRadius;

	// Alpha calculation (cloaking)
	float fAlpha	= (1.0f-fDelta) * time_A;
	fAlpha		= fAlpha + fDelta * time_B;

float4 vecPos = inPos;
	float fDist	= ((vecPos.y - vecCenter.y)+1)/2;
	vecPos.x = vecPos.x + (15 * (sin(fDist+time_B)) * (1.0-fAlpha));

   Out.Pos = mul( view_proj_matrix, vecPos );
   float3 view = mul( view_matrix, inPos );
   float3 viewNormal = mul((float3x3)view_matrix, (float3)inNorm);
   
   Out.Norm = viewNormal;
   Out.Tex = inTex;
Out.Tex1 = inTex;

float sinTime = sin(time_A * 3.14f);

	Out.c = 0;
//	Out.c.y = sinTime * 0.15f;
//	Out.c.z = sinTime * 0.35f;
	Out.c.w = fAlpha;

   return Out;
}

sampler2D baseMap;
float4 ambient;


float4 ps_main( float4 inDiffuse: COLOR0, float2 inTex: TEXCOORD0, 
    float3 inNormal : TEXCOORD2) : COLOR0
{
   float4 base = tex2D(baseMap, inTex);
   float4 diffuse = base * (dot(dlightPos, inNormal) + ambient);

diffuse.rgb += inDiffuse.rgb;
   diffuse.w = inDiffuse.w;

   return diffuse;      
}
