float4x4 view_proj_matrix;
float4x4 view_matrix;
float3 dlightPos;
float specularPower;

struct VS_OUTPUT 
{
   float4 Pos : POSITION;   
   float2 Tex : TEXCOORD0;
   float3 Norm : TEXCOORD2;
};

VS_OUTPUT vs_main( float4 inPos: POSITION, float2 inTex: TEXCOORD, float3 inNorm : NORMAL )
{
   VS_OUTPUT Out;

   Out.Pos = mul( view_proj_matrix, inPos );
   float3 view = mul( view_matrix, inPos );
   float3 viewNormal = mul((float3x3)view_matrix, (float3)inNorm);
   
   Out.Norm = viewNormal;
   Out.Tex = inTex;

   return Out;
}

sampler2D baseMap;
float4 ambient;

float4 ps_main( float4 inDiffuse: COLOR0, float2 inTex: TEXCOORD0, 
    float3 inNormal : TEXCOORD2) : COLOR0
{
   float4 base = tex2D(baseMap, inTex);
   float4 diffuse = dot(dlightPos, inNormal) + ambient;
   diffuse.w = 1;
      
   return base * diffuse;
}
