struct VS_OUTPUT {
   float4 Pos: POSITION;
   float2 texCoord: TEXCOORD0;
float temp : TEXCOORD1;
};

float onPlanet; 

VS_OUTPUT vs_main(float4 Pos: POSITION)
{
   VS_OUTPUT Out;

   // Clean up inaccuracies
   Pos.xy = sign(Pos.xy);

   Out.Pos = float4(Pos.xy, 0, 1);

   // Image-space

   Out.texCoord.x = 0.5 * (1 + Pos.x);
   Out.texCoord.y = 0.5 * (1 - Pos.y);

	Out.temp = onPlanet;

return Out;
}

sampler renderTexture: register(s0);

float BlurIntensity;

const float2 samples[8] = {
   -1, -1,
    0, -1,
    1, -1,
   -1,  0,
    1,  0,
   -1,  1,
    0,  1,
    1,  1,
};

// Simple blur filter
float4 ps_main(float2 texCoord: TEXCOORD0, float myThing : TEXCOORD1) : COLOR 
{

float4 sum = tex2D(renderTexture, texCoord);

const float4 sampleOffset = 1.0f / 512.0f;

sum += tex2D(renderTexture, texCoord + (sampleOffset * samples[0]));
sum += tex2D(renderTexture, texCoord + (sampleOffset * samples[1]));
sum += tex2D(renderTexture, texCoord + (sampleOffset * samples[2]));
sum += tex2D(renderTexture, texCoord + (sampleOffset * samples[4]));
sum += tex2D(renderTexture, texCoord + (sampleOffset * samples[5]));
sum += tex2D(renderTexture, texCoord + (sampleOffset * samples[6]));
sum += tex2D(renderTexture, texCoord + (sampleOffset * samples[7]));

return sum / 8;

return sum;
}


