struct VS_OUTPUT {
   float4 Pos: POSITION;
   float2 texCoord: TEXCOORD0;
   float2 texCoord1: TEXCOORD1;
   float2 texCoord2: TEXCOORD2;
   float2 texCoord3: TEXCOORD3;
};

VS_OUTPUT vs_main(float4 Pos: POSITION)
{
   VS_OUTPUT Out;

   // Clean up inaccuracies
   Pos.xy = sign(Pos.xy);

   Out.Pos = float4(Pos.xy, 0, 1);

   // Image-space

   Out.texCoord.x = 0.5 * (1 + Pos.x) - 0.0025;
   Out.texCoord.y = 0.5 * (1 - Pos.y);
   Out.texCoord1.x = 0.5 * (1 + Pos.x) + 0.0025;
   Out.texCoord1.y = 0.5 * (1 - Pos.y);
   Out.texCoord2.x = 0.5 * (1 + Pos.x) + 0.0035;
   Out.texCoord2.y = 0.5 * (1 - Pos.y);
   Out.texCoord3.x = 0.5 * (1 + Pos.x) - 0.0035;
   Out.texCoord3.y = 0.5 * (1 - Pos.y);

   return Out;
}


sampler renderTexture : register(S0);
sampler renderTexture1 : register(S1);
sampler renderTexture2 : register(S2);
sampler renderTexture3 : register(S3);

// Simple blur filter
float4 ps_main(float2 texCoord: TEXCOORD0, float2 texCoord1 : TEXCOORD1, float2 texCoord2 : TEXCOORD2, float2 texCoord3 : TEXCOORD3) : COLOR 
{
   float4 sum = tex2D(renderTexture, texCoord);
sum += tex2D(renderTexture1, texCoord1);
sum += tex2D(renderTexture2, texCoord2);
sum += tex2D(renderTexture3, texCoord3);

   return (sum / 2);
}


