float4x4 view_proj_matrix;
float4x4 view_matrix;
float3 dlightPos;
float specularPower;

bool direction;

float outerRadius;
float time_A;
float time_B;
float time;

struct VS_OUTPUT 
{
   float4 Pos : POSITION;   
   float4 c : COLOR0;
   float2 Tex : TEXCOORD0;
   float1 Tex1 : TEXCOORD1;
   float3 Norm : TEXCOORD2;
};

VS_OUTPUT vs_main( float4 inPos: POSITION, float2 inTex: TEXCOORD0, float3 inNorm : NORMAL )
{
   VS_OUTPUT Out;

   float3 vecCenter;
   vecCenter.x = vecCenter.y = vecCenter.z = 0.0f;

   // Relative distance of vertexposition to outer perimeter of the ship

   float4 vPos = inPos;
   
   time = abs(time);
   if (direction)
   {
      time = 1.0f - time;
   }
   
   

   float adjustedTime = abs(max(0,time - 0.5f));

   float fDelta, fDelta2;
      
   fDelta = abs(max(0, inPos.z));
   fDelta2 = abs(min(0, inPos.z));

   if (direction)
   {
         vPos.z -= (fDelta2 * 10 * time) + (fDelta * time);
         vPos.z -= (50 * adjustedTime);
   }
   else
   {
      vPos.z += (fDelta * 10 * time) + (fDelta * 5 * adjustedTime);
      vPos.z += (50 * adjustedTime);
   }
     
   Out.Pos = mul( view_proj_matrix, vPos );
   float3 view = mul( view_matrix, inPos );
   float3 viewNormal = mul((float3x3)view_matrix, (float3)inNorm);
   
   Out.Norm = viewNormal;
        Out.Tex = inTex;
        Out.Tex1 = inTex;
   Out.c = 1;
   Out.c.w = 1.0f - time;

   return Out;
}


sampler2D baseMap;
float4 ambient;


float4 ps_main( float4 inDiffuse: COLOR0, float2 inTex: TEXCOORD0, 
    float3 inNormal : TEXCOORD2) : COLOR0
{
   float4 base = tex2D(baseMap, inTex);
   float4 diffuse = base * (dot(dlightPos, inNormal) + ambient);

   diffuse.w = inDiffuse.w;

return diffuse;      
}
