float4x4 view_proj_matrix;
float4x4 view_matrix;
float4x4 normal_matrix;
float3 dlightPos;

struct VS_OUTPUT
{
   float4 Pos:     POSITION;
   float3 Norm   : TEXCOORD2;
   float3 View   : TEXCOORD3;
   float2 Tex : TEXCOORD0;
   float2 CloudTex : TEXCOORD1;
};

float cloudTime;

VS_OUTPUT vs_main( float4 inPos: POSITION, float4 inNorm : NORMAL, float2 inTex : TEXCOORD0, float2 
inTex2 : TEXCOORD1)
{
   VS_OUTPUT Out;

   Out.Pos = mul(view_proj_matrix, inPos);   
   Out.Tex = inTex;
   Out.CloudTex = inTex;
Out.CloudTex.x += cloudTime;

   Out.Norm = normalize(mul(normal_matrix, inNorm));
   Out.View = mul(view_matrix, inPos);

   return Out;
}

// ----------------- BEGIN PIXEL SHADER CONSTANTS -------------------

sampler baseMap : register(s0);
sampler cloudTex : register(s1);
float3 dlightColor;
float3 ambient;
float specularPower;



float4 ps_main( 
             float3 Normal : TEXCOORD2,
             float3 View   : TEXCOORD3,
             float2 Tex    : TEXCOORD0, float2 CloudTex : TEXCOORD1) : COLOR
{
	float4 color;

	    float3 diffuse = dot(Normal, dlightPos);
	   float3 albedo = tex2D(baseMap, Tex) + tex2D(cloudTex, CloudTex);
   
	   color.xyz = (diffuse * albedo);
	   color.w = 1;

return color;
}

