float4x4 view_proj_matrix;
float4x4 view_matrix;

struct VS_OUTPUT 
{
   float4 Pos:     POSITION;
   float3 Norm : TEXCOORD0;
   float3 View : TEXCOORD1;
};

VS_OUTPUT vs_main( float4 inPos: POSITION, float3 inNorm : NORMAL0 )
{
   VS_OUTPUT Out;

   float4 scaledPos = inPos; 

   scaledPos.xyz *= 1.0f;
   Out.Pos = mul(view_proj_matrix, scaledPos);
   
   // ps 1.1 packing song and dance

   Out.Norm = -normalize(mul((float3x3)view_matrix, inNorm)) * 0.5f + 0.5f;
   Out.View = -normalize(mul(view_matrix, scaledPos))  * 0.5f + 0.5f;

   return Out;
}

// Pixel Shader Definitions

float4 rim_color;
float3 dlightPos;

float4 ps_main( 
float3 inNorm : TEXCOORD0, 
float3 inView : TEXCOORD1 ) : COLOR0
{

// PS 1.1 packing song and dance again. (I feel like a Broadway Musical.)

   inNorm -= 0.5f;
   inNorm *= 2;

   inView -= 0.5f;
   inView *= 2;
   
   float rim = pow(1.0f - dot(inNorm, inView), 4);

   float4 color;

   color.xyzw = rim * rim_color;
   
   // this needs to be affected very slightly by dlight contribution

color *= saturate(dot(-inNorm, dlightPos) + 0.5f);
   return color;		// and call it good.
}
