// Try to figure THIS one out... ;)

float4x4 view_proj_matrix;
float4x4 view_matrix;

float4 quats[30];
float4 trans[30];

struct VS_OUTPUT 
{
   float4 Pos:  POSITION;
   float2 Tex : TEXCOORD0;
   float4 col : COLOR;
   float3 Norm : TEXCOORD1;
};

float4 QuatMult ( float4 Quat1, float4 Quat2 )
{
   float3 v; float s;
v  = (Quat1.xyz * Quat2.w) + (Quat2.xyz * Quat1.w) + cross(Quat1.xyz, Quat2.xyz);
s = Quat1.w * Quat2.w - dot(Quat1.xyz, Quat2.xyz);
   
   return float4(v,s);
}

VS_OUTPUT vs_main( float4 inPos: POSITION, float4 Bw : TEXCOORD2, float4 Bi : TEXCOORD1,
float4 inTex0 : TEXCOORD0, float3 inNorm : NORMAL )
{
	VS_OUTPUT Out;

	float BiArray[4] = (float[4])Bi;
	float BlendWeightsArray[4] = (float[4])Bw;
   
   float3 accumulator = (0,0,0);
   float3 accumNorm = (0,0,0);

   for (int i = 0; i <= 3; i++)
   {
      // first, the quaternion math.
      float boneIDX = BiArray[i];

	float4 quat = quats[boneIDX];
      float4 conj = quat;
      conj.x = -conj.x;
      conj.y = -conj.y;
      conj.z = -conj.z;

      float4 temp2 = QuatMult(float4(inPos.xyz,0), quat);
      float4 temp = QuatMult(conj, temp2);

      temp.xyz += trans[boneIDX].xyz;
      temp *= BlendWeightsArray[i];

      accumulator.xyz += temp.xyz;
      temp2 = QuatMult(float4(inNorm.xyz, 0), quat);
temp = QuatMult(conj, temp2);
temp *= BlendWeightsArray[i];
accumNorm.xyz += temp.xyz;

   }
   
   Out.Pos = mul(view_proj_matrix, float4(accumulator,1));
   Out.Norm = mul(view_matrix, accumNorm);
   Out.Tex = inTex0;
   Out.col = Bi;
      
   return Out;
}


// ----------------- BEGIN PIXEL SHADER CONSTANTS -------------------

sampler baseMap : register(s0);
float3 dlightColor;
float3 dlightPos;
float3 ambient;
float specularPower;

float4 ps_main( 
             float3 Normal : TEXCOORD1,
             float2 Tex    : TEXCOORD0) : COLOR
{
	float4 color;

        float3 diffuse = max(0,dot(Normal, dlightPos)) * dlightColor + ambient;
        float3 albedo = tex2D(baseMap, Tex);
   
        color.xyz = (diffuse * albedo);
        color.w = 1;

        return color;
}


